/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
	"fmt"
)

// CveGetFiltered200Response - struct for CveGetFiltered200Response
type CveGetFiltered200Response struct {
	CreateCveRecordRejectionResponse *CreateCveRecordRejectionResponse
	ListCveRecordsResponse *ListCveRecordsResponse
}

// CreateCveRecordRejectionResponseAsCveGetFiltered200Response is a convenience function that returns CreateCveRecordRejectionResponse wrapped in CveGetFiltered200Response
func CreateCveRecordRejectionResponseAsCveGetFiltered200Response(v *CreateCveRecordRejectionResponse) CveGetFiltered200Response {
	return CveGetFiltered200Response{
		CreateCveRecordRejectionResponse: v,
	}
}

// ListCveRecordsResponseAsCveGetFiltered200Response is a convenience function that returns ListCveRecordsResponse wrapped in CveGetFiltered200Response
func ListCveRecordsResponseAsCveGetFiltered200Response(v *ListCveRecordsResponse) CveGetFiltered200Response {
	return CveGetFiltered200Response{
		ListCveRecordsResponse: v,
	}
}


// Unmarshal JSON data into one of the pointers in the struct
func (dst *CveGetFiltered200Response) UnmarshalJSON(data []byte) error {
	var err error
	match := 0
	// try to unmarshal data into CreateCveRecordRejectionResponse
	err = newStrictDecoder(data).Decode(&dst.CreateCveRecordRejectionResponse)
	if err == nil {
		jsonCreateCveRecordRejectionResponse, _ := json.Marshal(dst.CreateCveRecordRejectionResponse)
		if string(jsonCreateCveRecordRejectionResponse) == "{}" { // empty struct
			dst.CreateCveRecordRejectionResponse = nil
		} else {
			match++
		}
	} else {
		dst.CreateCveRecordRejectionResponse = nil
	}

	// try to unmarshal data into ListCveRecordsResponse
	err = newStrictDecoder(data).Decode(&dst.ListCveRecordsResponse)
	if err == nil {
		jsonListCveRecordsResponse, _ := json.Marshal(dst.ListCveRecordsResponse)
		if string(jsonListCveRecordsResponse) == "{}" { // empty struct
			dst.ListCveRecordsResponse = nil
		} else {
			match++
		}
	} else {
		dst.ListCveRecordsResponse = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.CreateCveRecordRejectionResponse = nil
		dst.ListCveRecordsResponse = nil

		return fmt.Errorf("data matches more than one schema in oneOf(CveGetFiltered200Response)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(CveGetFiltered200Response)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src CveGetFiltered200Response) MarshalJSON() ([]byte, error) {
	if src.CreateCveRecordRejectionResponse != nil {
		return json.Marshal(&src.CreateCveRecordRejectionResponse)
	}

	if src.ListCveRecordsResponse != nil {
		return json.Marshal(&src.ListCveRecordsResponse)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *CveGetFiltered200Response) GetActualInstance() (interface{}) {
	if obj == nil {
		return nil
	}
	if obj.CreateCveRecordRejectionResponse != nil {
		return obj.CreateCveRecordRejectionResponse
	}

	if obj.ListCveRecordsResponse != nil {
		return obj.ListCveRecordsResponse
	}

	// all schemas are nil
	return nil
}

type NullableCveGetFiltered200Response struct {
	value *CveGetFiltered200Response
	isSet bool
}

func (v NullableCveGetFiltered200Response) Get() *CveGetFiltered200Response {
	return v.value
}

func (v *NullableCveGetFiltered200Response) Set(val *CveGetFiltered200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableCveGetFiltered200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableCveGetFiltered200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCveGetFiltered200Response(val *CveGetFiltered200Response) *NullableCveGetFiltered200Response {
	return &NullableCveGetFiltered200Response{value: val, isSet: true}
}

func (v NullableCveGetFiltered200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCveGetFiltered200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


